/*
	InerziaTimer versione 2.0
    aggiunto timer per salvare il record uptime
*/

//	init some variables

var oraID = null;				// indice del timer per aggiornamento uptime
var maxID = null;               // indice del timer per registrazione max uptime
var timerAttivo = false;		// timer attivo flag
var saveAttivo = false;         // save attivo flag
secPerHr = 60 * 60;				// secondi per ora
secPerDay = 24 * secPerHr;		// secondi per giorno
secPerMin = 60;					// secondi per minuto
var gDoneButton;				// btn per tornare al front
var gInfoButton;				// per andare al back
var gDeltaT;					// intervallo del timer di aggiornamento (ms)
var gSkin;						// skin da usare
var gdataBoot = new Date;		// data ultimo boot
var gDataStrBoot;				// stringa che contiene data ultimo boot come stringa
var gNumOptionTimer = 6;		// numero di opzioni timer nelle preferenze
var	gNumOptionSkin = 7;			// numero di opzioni skin nelle preferenze
var gNumOptionSave = 7;         // numero di opzioni timer save nelle preferenze
var gVersione = "2.0";			// versione widget
var gDeltaSave;                 // intervallo del timer di registrazione uptime massimo (2.0)
var gUptime;					// valore attuale uptime
var gMaxUptime;					// valore record uptime
								// usiamo formato locale per tutti i tempi

imgBlue = new Image(209,92);		
imgBlue.src = 'blue.png';
imgGreen = new Image(209,92);		
imgGreen.src = 'green.png';
imgRed = new Image(209,92);			
imgRed.src = 'red.png';
imgMagenta = new Image(209,92);		
imgMagenta.src = 'magenta.png';
imgYellow = new Image(209,92);		
imgYellow.src = 'yellow.png';
imgGrey = new Image(209,92);		
imgGrey.src = 'grey.png';
imgWhite = new Image(209,92);
imgWhite.src = 'white.png';

// routine chiamate agli eventi show e hide

if(window.widget)
{
	widget.onshow = startTimer;
	widget.onhide = stopTimer;
}

//	----------------------------------------------
//	chiamata alla partenza del widget
//	costruisce le stringhe locali, i pulsanti Done e Info,
//	legge dalle preferenze l'intervallo di update; se non c' lo imposta a 1000
//	legge dalle preferenze la skin; se non c' la mette uguale al grigio
//  legge dalle preferenze l'intervallo di salvataggio; se non c' lo disabilita (=0)
//	imposta il timer
//	----------------------------------------------
function setup()
{
if(window.widget)	{

	var mesi = new Array("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");		
							// non c' bisogno che i mesi siano localized:
							// vengono utilizzati sulla data in uscita da sysctl, sempre in inglese
							// data del boot viene letta e scritta una volta sola
				// cerca parola boottime, magari non cambier

	var testoBoot1 = (widget.system("/usr/sbin/sysctl -a | grep 'boottime = '", null).outputString);
	var posizione = testoBoot1.indexOf("boottime = ") + 11 + 4;		//elimina anche giorno settimana
	var testoBoot = testoBoot1.substr(posizione,testoBoot1.length - posizione);
	
	var meseBoot = testoBoot.substring(0,3);		// mese ultimo boot
	
	x = 0;
	while ( (x<12) && (meseBoot != mesi[x++]) );	// trova numero mese
	
	gdataBoot.setFullYear( testoBoot.substring(16,20), x-1, testoBoot.substring(4,6) );
	gdataBoot.setHours( testoBoot.substring(7,9), testoBoot.substring(10,12), testoBoot.substring(13,15));

	gDataStrBoot = gdataBoot.toLocaleString();
	gDataStrBoot = gDataStrBoot.substring( 0, gDataStrBoot.indexOf('GMT') );

    document.getElementById('lblDay').innerText = getLocalizedString('Giorni');
    document.getElementById('lblHr').innerText = getLocalizedString('Ore');
    document.getElementById('lblMin').innerText = getLocalizedString('Minuti');
    document.getElementById('lblSec').innerText = getLocalizedString('Secondi');
    document.getElementById('lblBoot').innerText = getLocalizedString('UltimoBoot');
    document.getElementById('deltaLbl1').innerText = getLocalizedString('Conteggio');
    document.getElementById('skinLbl').innerText = getLocalizedString('colore');
	document.getElementById('saveLbl').innerText = getLocalizedString('Registra');
	document.getElementById('menuSalvaMai').innerText = getLocalizedString('Mai');
	document.getElementById('menuSalvaApri').innerText = getLocalizedString('Apertura');
    el = document.getElementById('skin');
    el.options[0].text = getLocalizedString('blue');
    el.options[1].text = getLocalizedString('green');
    el.options[2].text = getLocalizedString('red');
    el.options[3].text = getLocalizedString('magenta');
    el.options[4].text = getLocalizedString('yellow');
    el.options[5].text = getLocalizedString('grey');
    el.options[6].text = getLocalizedString('white');
    
    gDoneButton = new AppleGlassButton(document.getElementById("doneBtn"), getLocalizedString('fatto'), hidePrefs);
	gDelUptButton = new AppleGlassButton(document.getElementById("deleteRecBtn"), "X", deleteRecord);
	gHelpBtn = new AppleGlassButton(document.getElementById("helpBtn"), "?", helpOnLine);
    gInfoButton = new AppleInfoButton(document.getElementById("infoBtn"), document.getElementById("front"), "white", "white", showPrefs); 
    
	var deltaT = widget.preferenceForKey("updateInterval"); // legge intervallo update
	if (deltaT == undefined) {deltaT = 1000;}               // se non esiste -> default
	gDeltaT = deltaT;
    
    var deltaT1 = widget.preferenceForKey("updateSave");    // legge intervallo save
    if (deltaT1 == undefined) {deltaT1 = 0};                // se non esiste -> default, no save
    gDeltaSave = deltaT1;
	
	gSkin = widget.preferenceForKey("defaultSkin");         // legge skin
	if (gSkin == undefined) {gSkin = 'grey';}               // se non esiste -> grigio
	changeSkin(gSkin);
	
	gMaxUptime = widget.preferenceForKey('maxUptime');		// legge record
	if (gMaxUptime == undefined) {gMaxUptime = "0";}			// se non esiste -> 0
	
	//gVersione = (widget.system('/usr/bin/defaults read "Info" CFBundleShortVersionString',null).outputString);
	document.getElementById('versione').innerText = gVersione;      //impostata: per ora non sappiamo come leggerla!
	
	var vect = new Array(3);
	vect = sec2DateArray(gMaxUptime);
	document.getElementById('recordUptime').innerText = (gMaxUptime > 0) ? vect[0]+"d "+vect[1]+":"+vect[2] : "----";
	}
	
}


// called every time Dashboard is shown ma anche ad ogni scadenza del timer
// legge ora, fa differenza rispetto al boot scrive risultato in formato corretto
function uptime()
{
	if(window.widget)
	{
		var adesso = new Date()
		var vettore = new Array(3);
		
		document.getElementById("fldBoot").innerText = gDataStrBoot; // non sarebbe meglio metterlo nel setup?
		var delta = adesso - gdataBoot;
		gUptime = delta;
		
		vettore = sec2DateArray(delta);
		document.getElementById("fldDay").innerText = vettore[0];
		document.getElementById("fldHr").innerText = vettore[1];
		document.getElementById("fldMin").innerText = vettore[2];
		document.getElementById("fldSec").innerText = vettore[3];
		
	}
}

// ingresso: secondi
// uscita: array con giorni-ore-minuti-secondi
function sec2DateArray(msecTot)
{
	sec = Math.floor(msecTot/1000);
	day = Math.floor(sec/secPerDay);
	sec %= secPerDay;
	hr = Math.floor(sec/secPerHr);
	sec %= secPerHr;
	min = Math.floor(sec/secPerMin);
	sec %= secPerMin;
	
	hr = (hr < 10) ? "0"+hr : hr;
	min = (min < 10) ? "0"+min : min;
	sec = (sec < 10) ? "0"+sec : sec;
	
	var dateArray = new Array(day,hr,min,sec);
	return dateArray;
}


function stopTimer()
{
	if (timerAttivo)	{
		clearInterval(oraID);
		timerAttivo = false;
	}
	
	if (gDeltaSave > 1)	{
		clearInterval(maxID);
		saveAttivo = false;
	}
	if (gDeltaSave !=0) {
		writeUptimeRecord();
	}
}

function startTimer()
{
	stopTimer();
	oraID = setInterval("uptime()",gDeltaT);
	timerAttivo = true;
	
    if (gDeltaSave == 1) {		// solo all'apertura
        writeUptimeRecord();
    }
	else if (gDeltaSave > 1) {		// intervallo normale
		maxID = setInterval("writeUptimeRecord()",gDeltaSave);
		saveAttivo = true;
	}
}

//
// check e scrive record se necessario
// nelle preferenze e nel riquadro dei record
//
function writeUptimeRecord()	{
	var vect = new Array(3);
	if (gUptime > gMaxUptime)	{
		widget.setPreferenceForKey(gUptime.toString(), 'maxUptime');
		vect = sec2DateArray(gUptime);
		document.getElementById('recordUptime').innerText = vect[0]+"d "+vect[1]+":"+vect[2];
	}
}

// cancella/resetta il record di uptime
// sia come display che nel plist
function deleteRecord()	{
	document.getElementById('recordUptime').innerText = "----";
	widget.setPreferenceForKey("0", 'maxUptime');
}


//
//	chiamata quando il menu deltaT nelle preferenze  cambiato
//	Non fa nulla per ora
//
function deltaPrefChanged(menuPref)
{
	
	
}


//	chiamata prima di tornare al front da hidePrefs
//	setta il timer al valore del menu, anche se non  cambiato...
//	impone la nuova skin
//	Registra anche le preferenze nel plist
function preparaFront()
{
	var myMenu = document.getElementById('intervallo');
	gDeltaT = myMenu.options[myMenu.selectedIndex].value;
	widget.setPreferenceForKey(gDeltaT, 'updateInterval');
	
	
	myMenu = document.getElementById('skin');
	var skin = myMenu.options[myMenu.selectedIndex].value;
	if (skin != gSkin)	{
		changeSkin(skin);
		gSkin = skin;
		widget.setPreferenceForKey(gSkin, 'defaultSkin');
	}
    
    myMenu = document.getElementById('deltaRec');
    gDeltaSave = myMenu.options[myMenu.selectedIndex].value;
    widget.setPreferenceForKey(gDeltaSave, 'updateSave');
    
    startTimer();
}

//	cambia la skin impostata nelle preferenze ed il colore del testo versione
function changeSkin(pelle)
{
	switch (pelle)
	{
		case 'blue':
			document.getElementById('imgFront').src = imgBlue.src;
			document.getElementById('versione').style.color = "#0000FF";
            gInfoButton.setStyle("white","white");
			break;
		case 'green':
			document.getElementById('imgFront').src = imgGreen.src;
			document.getElementById('versione').style.color = "#FF0000";
            gInfoButton.setStyle("white","white");
			break;
		case 'red':
			document.getElementById('imgFront').src = imgRed.src;
			document.getElementById('versione').style.color = "#000000";
            gInfoButton.setStyle("white","white");
			break;
		case 'magenta':
			document.getElementById('imgFront').src = imgMagenta.src;
			document.getElementById('versione').style.color = "#FFFFFF";
            gInfoButton.setStyle("white","white");
			break;
		case 'yellow':
			document.getElementById('imgFront').src = imgYellow.src;
			document.getElementById('versione').style.color = "#FF0000";
            gInfoButton.setStyle("black","black");
			break;
		case 'grey':
			document.getElementById('imgFront').src = imgGrey.src;
			document.getElementById('versione').style.color = "#FF0000";
            gInfoButton.setStyle("white","white");
            break;
        case 'white':
            document.getElementById('imgFront').src = imgWhite.src;
            document.getElementById('versione').style.color = "#FF0000";
            gInfoButton.setStyle("black","black");
	}
	
}


//	chiamata prima di passare al back da showPrefs
//	setta il menu al valore del timer andando a vedere quale voce  uguale al timer
//	la stessa cosa per settare il colore dell'interfaaccia
function preparaBack()
{
    stopTimer();
    
	var myMenu = document.getElementById('intervallo');     // menu update
	for (x=0; x<gNumOptionTimer; x++)	{
		if (myMenu.options[x].value == gDeltaT)	{
			myMenu.selectedIndex = x;
			break;
		}
	}
	
	myMenu = document.getElementById('skin');               // menu skin
	for (x=0; x<gNumOptionSkin; x++)	{
		if (myMenu.options[x].value == gSkin)	{
			myMenu.selectedIndex = x;
			break;
		}
	}
    
    myMenu = document.getElementById('deltaRec');           // menu deltaRec
    for (x=0; x<gNumOptionSave; x++)    {
        if (myMenu.options[x].value == gDeltaSave)  {
            myMenu.selectedIndex = x;
            break;
        }
    }
}

// ---- routine per animazione e infoButton  ------

//	aggiunta chiamata preparaBack per preparare il menu deltaT
function showPrefs() 
{ 
	preparaBack();

    var front = document.getElementById("front"); 
    var back = document.getElementById("back"); 
    if (window.widget) 
        widget.prepareForTransition("ToBack"); 
    front.style.display="none"; 
    back.style.display="block"; 
    if (window.widget) 
        setTimeout ('widget.performTransition();', 0);  
} 

//	aggiunta chiamata preparaFront: resetta e setta il timer con eventuale nuovo valore deltaT
function hidePrefs() 
{ 
	preparaFront();
	
    var front = document.getElementById("front"); 
    var back = document.getElementById("back"); 
    if (window.widget) 
        widget.prepareForTransition("ToFront"); 
    back.style.display="none"; 
    front.style.display="block"; 
    if (window.widget) 
        setTimeout ('widget.performTransition();', 0);
} 

function helpOnLine()	{
	widget.openURL('http://www.inerziasoft.eu/en/help/uptimeHelp.html');
}

//	per caricare le stringhe localizzate
function getLocalizedString (key)
{
	try {
		var ret = localizedStrings[key];
		if (ret === undefined)
			ret = key;
		return ret;
	} catch (ex) {}
	
	return key;
}